
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Job_requisitionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_requisitions = await db.job_requisitions.create(
            {
                id: data.id || undefined,
        
        requestingDept: data.requestingDept
        ||
        null
            ,
            
        positionTitle: data.positionTitle
        ||
        null
            ,
            
        numberOfVacancies: data.numberOfVacancies
        ||
        null
            ,
            
        justification: data.justification
        ||
        null
            ,
            
        requiredSkills: data.requiredSkills
        ||
        null
            ,
            
        salaryRangeFrom: data.salaryRangeFrom
        ||
        null
            ,
            
        salaryRangeTo: data.salaryRangeTo
        ||
        null
            ,
            
        targetStartDate: data.targetStartDate
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await job_requisitions.setApprovedByManagerUser( data.approvedByManagerUser || null, {
            transaction,
        });
        
        await job_requisitions.setApprovedByHrUser( data.approvedByHrUser || null, {
            transaction,
        });
        

        

        

        return job_requisitions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const job_requisitionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                requestingDept: item.requestingDept
            ||
            null
            ,
            
                positionTitle: item.positionTitle
            ||
            null
            ,
            
                numberOfVacancies: item.numberOfVacancies
            ||
            null
            ,
            
                justification: item.justification
            ||
            null
            ,
            
                requiredSkills: item.requiredSkills
            ||
            null
            ,
            
                salaryRangeFrom: item.salaryRangeFrom
            ||
            null
            ,
            
                salaryRangeTo: item.salaryRangeTo
            ||
            null
            ,
            
                targetStartDate: item.targetStartDate
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const job_requisitions = await db.job_requisitions.bulkCreate(job_requisitionsData, { transaction });

        // For each item created, replace relation files
        

        return job_requisitions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const job_requisitions = await db.job_requisitions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.requestingDept !== undefined) updatePayload.requestingDept = data.requestingDept;
        
        
        if (data.positionTitle !== undefined) updatePayload.positionTitle = data.positionTitle;
        
        
        if (data.numberOfVacancies !== undefined) updatePayload.numberOfVacancies = data.numberOfVacancies;
        
        
        if (data.justification !== undefined) updatePayload.justification = data.justification;
        
        
        if (data.requiredSkills !== undefined) updatePayload.requiredSkills = data.requiredSkills;
        
        
        if (data.salaryRangeFrom !== undefined) updatePayload.salaryRangeFrom = data.salaryRangeFrom;
        
        
        if (data.salaryRangeTo !== undefined) updatePayload.salaryRangeTo = data.salaryRangeTo;
        
        
        if (data.targetStartDate !== undefined) updatePayload.targetStartDate = data.targetStartDate;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await job_requisitions.update(updatePayload, {transaction});

        
        
        if (data.approvedByManagerUser !== undefined) {
            await job_requisitions.setApprovedByManagerUser(
              
              data.approvedByManagerUser,
              
              { transaction }
            );
        }
        
        if (data.approvedByHrUser !== undefined) {
            await job_requisitions.setApprovedByHrUser(
              
              data.approvedByHrUser,
              
              { transaction }
            );
        }
        

        
        

        

        return job_requisitions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const job_requisitions = await db.job_requisitions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of job_requisitions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of job_requisitions) {
                await record.destroy({transaction});
            }
        });


        return job_requisitions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const job_requisitions = await db.job_requisitions.findByPk(id, options);

        await job_requisitions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await job_requisitions.destroy({
            transaction
        });

        return job_requisitions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const job_requisitions = await db.job_requisitions.findOne(
            { where },
            { transaction },
        );

        if (!job_requisitions) {
            return job_requisitions;
        }

        const output = job_requisitions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.applicants_jobRequisition = await job_requisitions.getApplicants_jobRequisition({
            transaction
        });
        
        
        
        
        
        
        
        
        
        output.approvedByManagerUser = await job_requisitions.getApprovedByManagerUser({
            transaction
        });
        
        
        output.approvedByHrUser = await job_requisitions.getApprovedByHrUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'approvedByManagerUser',
        
        where: filter.approvedByManagerUser ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approvedByManagerUser.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.approvedByManagerUser.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'approvedByHrUser',
        
        where: filter.approvedByHrUser ? {
          [Op.or]: [
            { id: { [Op.in]: filter.approvedByHrUser.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.approvedByHrUser.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.requestingDept) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_requisitions',
                        'requestingDept',
                        filter.requestingDept,
                    ),
                };
            }
            
            if (filter.positionTitle) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_requisitions',
                        'positionTitle',
                        filter.positionTitle,
                    ),
                };
            }
            
            if (filter.justification) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_requisitions',
                        'justification',
                        filter.justification,
                    ),
                };
            }
            
            if (filter.requiredSkills) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'job_requisitions',
                        'requiredSkills',
                        filter.requiredSkills,
                    ),
                };
            }
            

            
            

            
            if (filter.numberOfVacanciesRange) {
                const [start, end] = filter.numberOfVacanciesRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    numberOfVacancies: {
                    ...where.numberOfVacancies,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    numberOfVacancies: {
                    ...where.numberOfVacancies,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.salaryRangeFromRange) {
                const [start, end] = filter.salaryRangeFromRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    salaryRangeFrom: {
                    ...where.salaryRangeFrom,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    salaryRangeFrom: {
                    ...where.salaryRangeFrom,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.salaryRangeToRange) {
                const [start, end] = filter.salaryRangeToRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    salaryRangeTo: {
                    ...where.salaryRangeTo,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    salaryRangeTo: {
                    ...where.salaryRangeTo,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.targetStartDateRange) {
                const [start, end] = filter.targetStartDateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    targetStartDate: {
                    ...where.targetStartDate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    targetStartDate: {
                    ...where.targetStartDate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.job_requisitions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'job_requisitions',
                        'positionTitle',
                        query,
                    ),
                ],
            };
        }

        const records = await db.job_requisitions.findAll({
            attributes: [ 'id', 'positionTitle' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['positionTitle', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.positionTitle,
        }));
    }

    
};

